-- Author: Ketho (EU-Boulderfist)
-- License: Public Domain

if time() > 1472688000 then -- September 1, 2016
	print("Legion invasions are over, disabling DreadWhisperForInvite...")
	DisableAddOn("DreadWhisperForInvite")
	return
end

local NAME, S = ...
local L = S.L -- localization

local e = {} -- events
local f = CreateFrame("Frame")

local whispered = {}
local killed

local mapIDs = {
	[301] = true, -- Stormwind
	[321] = true, -- Orgrimmar
}

hooksecurefunc("LFGListEntryCreation_ListGroup", function()
	if mapIDs[GetCurrentMapAreaID()] then
		f:SetEnabledState(true)
	end
end)

LFGListFrame.ApplicationViewer.RemoveEntryButton:HookScript("OnClick", function()
	f:SetEnabledState(false)
end)

function e:CHAT_MSG_WHISPER(event, msg, unit)
	local numMembers = GetNumGroupMembers(LE_PARTY_CATEGORY_HOME)
	
	-- C_LFGList.GetNumInvitedApplicantMembers only is meaningful
	-- when using C_LFGList.InviteApplicant and we dont want to use that
	if numMembers < MAX_RAID_MEMBERS then
		InviteUnit(unit)
	else
		if not whispered[unit] then
			whispered[unit] = true --  Dreadlord is dead or raid is full
			SendChatMessage(killed and L.FINISHED or L.RAID_FULL, "WHISPER", nil, unit)
		end
	end
	
	if not IsInRaid() then
		ConvertToRaid()
	end
end

function e:COMBAT_LOG_EVENT_UNFILTERED(event, timestamp, subevent, _, sourceGUID, sourceName, _, _, destGUID, destName)
	if subevent == "UNIT_DIED" then
		local npcId = select(6, strsplit("-", destGUID))
		if tonumber(npcId) == 112198 then
			killed = true 
			C_Timer.After(15, function()
				f:SetEnabledState(false)
				killed = false
			end)
		end
	end
end

function f:SetEnabledState(enable)
	local method = enable and "RegisterEvent" or "UnregisterEvent"
	for k in pairs(e) do
		self[method](self, k)
	end
end

f:SetScript("OnEvent", function(self, event, ...)
	e[event](self, event, ...)
end)
